blob: b5c729d29726c31ea98a666ec9fe0ab048f16b97 [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Roland Levillain39341922015-10-20 12:48:19 +010047Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070048- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080049- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070050
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070051Look at the source to view more functions. The complete list is:
52EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070053 local T=$(gettop)
54 local A=""
55 local i
Jacky Cao89483b82015-05-15 22:12:53 +080056 for i in `cat $T/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070057 A="$A $i"
58 done
59 echo $A
60}
61
Ying Wang08800fd2016-03-03 20:57:21 -080062# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000063function build_build_var_cache()
64{
Christopher Ferris55257d22017-03-23 11:08:58 -070065 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080066 # Grep out the variable names from the script.
Jim Tanga881a252018-06-19 16:34:41 +080067 cached_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
68 cached_abs_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080069 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080070 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080071 --vars="${cached_vars[*]}" \
72 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070073 --var-prefix=var_cache_ \
74 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080075 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000076 if [ $ret -ne 0 ]
77 then
Ying Wang08800fd2016-03-03 20:57:21 -080078 unset build_dicts_script
79 return $ret
80 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070081 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080082 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080083 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080084 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000085 if [ $ret -ne 0 ]
86 then
Ying Wang08800fd2016-03-03 20:57:21 -080087 return $ret
88 fi
89 BUILD_VAR_CACHE_READY="true"
90}
91
Ying Wangf0cb3972016-03-04 13:56:23 -080092# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -080093# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +000094function destroy_build_var_cache()
95{
Ying Wang08800fd2016-03-03 20:57:21 -080096 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -070097 local v
Ying Wang08800fd2016-03-03 20:57:21 -080098 for v in $cached_vars; do
99 unset var_cache_$v
100 done
101 unset cached_vars
102 for v in $cached_abs_vars; do
103 unset abs_var_cache_$v
104 done
105 unset cached_abs_vars
106}
107
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700108# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000109function get_abs_build_var()
110{
111 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
112 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800113 eval "echo \"\${abs_var_cache_$1}\""
Timi0469c3f2021-04-15 16:41:18 +0200114 return
Ying Wang08800fd2016-03-03 20:57:21 -0800115 fi
116
Christopher Ferris55257d22017-03-23 11:08:58 -0700117 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700118 if [ ! "$T" ]; then
119 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
120 return
121 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700122 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700123}
124
125# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000126function get_build_var()
127{
128 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
129 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800130 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100131 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800132 fi
133
Christopher Ferris55257d22017-03-23 11:08:58 -0700134 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700135 if [ ! "$T" ]; then
136 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100137 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700138 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700139 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800140}
141
142# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000143function check_product()
144{
Christopher Ferris55257d22017-03-23 11:08:58 -0700145 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800146 if [ ! "$T" ]; then
147 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
148 return
149 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700150 TARGET_PRODUCT=$1 \
151 TARGET_BUILD_VARIANT= \
152 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700153 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800154 get_build_var TARGET_DEVICE > /dev/null
155 # hide successful answers, but allow the errors to show
156}
157
158VARIANT_CHOICES=(user userdebug eng)
159
160# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000161function check_variant()
162{
Christopher Ferris55257d22017-03-23 11:08:58 -0700163 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800164 for v in ${VARIANT_CHOICES[@]}
165 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000166 if [ "$v" = "$1" ]
167 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 return 0
169 fi
170 done
171 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700172}
173
Matt Alexanderd9c56562020-05-21 10:49:17 +0000174function setpaths()
175{
Christopher Ferris55257d22017-03-23 11:08:58 -0700176 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700177 if [ ! "$T" ]; then
178 echo "Couldn't locate the top of the tree. Try setting TOP."
179 return
180 fi
181
182 ##################################################################
183 # #
184 # Read me before you modify this code #
185 # #
186 # This function sets ANDROID_BUILD_PATHS to what it is adding #
187 # to PATH, and the next time it is run, it removes that from #
188 # PATH. This is required so lunch can be run more than once #
189 # and still have working paths. #
190 # #
191 ##################################################################
192
Raphael Mollc639c782011-06-20 17:25:01 -0700193 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
194 # due to "C:\Program Files" being in the path.
195
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700196 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000197 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700198 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
199 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000200 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700201 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800202 # strip leading ':', if any
203 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500204 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700205
206 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700207 local prebuiltdir=$(getprebuilt)
208 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700209
Ben Cheng8bc4c432012-11-16 13:29:13 -0800210 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700211 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
212 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800213 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800214
Raphael Mollc639c782011-06-20 17:25:01 -0700215 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800216 export ANDROID_TOOLCHAIN=
217 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200218 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700219 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200220 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000221 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700222 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000223 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400224 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000225 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200226 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000227 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
228 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700229 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200230 *)
231 echo "Can't find toolchain for unknown architecture: $ARCH"
232 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700233 ;;
234 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700235 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800236 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700237 fi
Raphael732936d2011-06-22 14:35:32 -0700238
Christopher Ferris55257d22017-03-23 11:08:58 -0700239 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800240 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
241 fi
242
Jeff Vander Stoep5f50f052015-06-12 09:56:39 -0700243 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools:$T/external/selinux/prebuilts/bin
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700244
245 # add kernel specific binaries
246 case $(uname -s) in
247 Linux)
248 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
249 ;;
250 *)
251 ;;
252 esac
253
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400254 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
255 if [ -n "$ANDROID_TOOLCHAIN_2ND_ARCH" ]; then
256 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
257 fi
Yi Kongdfd00b12019-05-21 16:00:04 -0700258 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
259
260 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
261 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
262 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200263
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800264 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
265 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
266
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200267 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
268 # to ensure that the corresponding 'emulator' binaries are used.
269 case $(uname -s) in
270 Darwin)
271 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
272 ;;
273 Linux)
274 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
275 ;;
276 *)
277 ANDROID_EMULATOR_PREBUILTS=
278 ;;
279 esac
280 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700281 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200282 export ANDROID_EMULATOR_PREBUILTS
283 fi
284
Jim Tangb3fda302018-12-22 10:24:55 +0800285 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
286 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700287 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
288 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
289 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
290 export ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH:
Jim Tangb3fda302018-12-22 10:24:55 +0800291
Ryan Prichard8426a192019-07-15 18:05:29 -0700292 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800293
294 # out with the duplicate old
295 if [ -n $ANDROID_PYTHONPATH ]; then
296 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
297 fi
298 # and in with the new
299 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800300 if [ -n $VENDOR_PYTHONPATH ]; then
301 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
302 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800303 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800304
Colin Crosse97e6932017-06-30 16:01:45 -0700305 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
306 export JAVA_HOME=$ANDROID_JAVA_HOME
307 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
308 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
309 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500310
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800311 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700312 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
313 export OUT=$ANDROID_PRODUCT_OUT
314
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700315 unset ANDROID_HOST_OUT
316 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
317
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900318 unset ANDROID_SOONG_HOST_OUT
319 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
320
Simran Basidd050ed2017-02-13 13:46:48 -0800321 unset ANDROID_HOST_OUT_TESTCASES
322 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
323
324 unset ANDROID_TARGET_OUT_TESTCASES
325 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
326
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800327 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700328 # TODO: fix the path
329 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
330}
331
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000332function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000333{
334 local T="$(gettop)"
335 if [ ! "$T" ]; then
336 echo "Couldn't locate the top of the tree. Try setting TOP."
337 return
338 fi
339
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000340 if which bazel &>/dev/null; then
Jingwen Chenc8b5e192020-12-14 10:28:33 -0500341 >&2 echo "NOTE: bazel() function sourced from envsetup.sh is being used instead of $(which bazel)"
342 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000343 fi
344
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000345 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000346}
347
Matt Alexanderd9c56562020-05-21 10:49:17 +0000348function printconfig()
349{
Christopher Ferris55257d22017-03-23 11:08:58 -0700350 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800351 if [ ! "$T" ]; then
352 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
353 return
354 fi
355 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700356}
357
Matt Alexanderd9c56562020-05-21 10:49:17 +0000358function set_stuff_for_environment()
359{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800360 setpaths
361 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700362
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800363 export ANDROID_BUILD_TOP=$(gettop)
Ben Chengaac3f812013-08-13 14:38:15 -0700364 # With this environment variable new GCC can apply colors to warnings/errors
365 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700366}
367
Matt Alexanderd9c56562020-05-21 10:49:17 +0000368function set_sequence_number()
369{
Colin Cross88737132017-03-21 17:41:03 -0700370 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700371}
372
Makoto Onukida971062018-06-18 10:15:19 -0700373# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
374function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800375 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700376 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800377 *:"$cmd":*)
378 return 1
379 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700380 esac
381 return 0
382}
383
Matt Alexanderd9c56562020-05-21 10:49:17 +0000384function addcompletions()
385{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700386 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700387
Jim Tanga881a252018-06-19 16:34:41 +0800388 # Keep us from trying to run in something that's neither bash nor zsh.
389 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700390 return
391 fi
392
393 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800394 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700395 return
396 fi
397
Jim Tanga881a252018-06-19 16:34:41 +0800398 local completion_files=(
399 system/core/adb/adb.bash
400 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800401 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800402 )
Makoto Onukida971062018-06-18 10:15:19 -0700403 # Completion can be disabled selectively to allow users to use non-standard completion.
404 # e.g.
405 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
406 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Jim Tanga881a252018-06-19 16:34:41 +0800407 for f in ${completion_files[*]}; do
408 if [ -f "$f" ] && should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700409 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700410 fi
411 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700412
Matt Alexanderd9c56562020-05-21 10:49:17 +0000413 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700414 complete -C "bit --tab" bit
415 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000416 if [ -z "$ZSH_VERSION" ]; then
417 # Doesn't work in zsh.
418 complete -o nospace -F _croot croot
419 fi
Jim Tanga881a252018-06-19 16:34:41 +0800420 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800421
Cole Faust24c36db2021-01-23 02:39:37 +0000422 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100423 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000424 complete -F _complete_android_module_names outmod
425 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100426 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700427}
428
Matt Alexanderd9c56562020-05-21 10:49:17 +0000429function choosetype()
430{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700431 echo "Build type choices are:"
432 echo " 1. release"
433 echo " 2. debug"
434 echo
435
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800436 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700437 DEFAULT_NUM=1
438 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700439
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800440 export TARGET_BUILD_TYPE=
441 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700442 while [ -z $TARGET_BUILD_TYPE ]
443 do
444 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000445 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800446 read ANSWER
447 else
448 echo $1
449 ANSWER=$1
450 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700451 case $ANSWER in
452 "")
453 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
454 ;;
455 1)
456 export TARGET_BUILD_TYPE=release
457 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800458 release)
459 export TARGET_BUILD_TYPE=release
460 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700461 2)
462 export TARGET_BUILD_TYPE=debug
463 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800464 debug)
465 export TARGET_BUILD_TYPE=debug
466 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700467 *)
468 echo
469 echo "I didn't understand your response. Please try again."
470 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700471 ;;
472 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000473 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800474 break
475 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700476 done
477
Ying Wang08800fd2016-03-03 20:57:21 -0800478 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700479 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800480 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700481}
482
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800483#
484# This function isn't really right: It chooses a TARGET_PRODUCT
485# based on the list of boards. Usually, that gets you something
486# that kinda works with a generic product, but really, you should
487# pick a product by name.
488#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000489function chooseproduct()
490{
Christopher Ferris55257d22017-03-23 11:08:58 -0700491 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000492 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700493 default_value=$TARGET_PRODUCT
494 else
Ying Wang0a76df52015-06-08 11:57:26 -0700495 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700496 fi
497
Ying Wang08800fd2016-03-03 20:57:21 -0800498 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800499 export TARGET_PRODUCT=
500 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700501 while [ -z "$TARGET_PRODUCT" ]
502 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700503 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000504 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800505 read ANSWER
506 else
507 echo $1
508 ANSWER=$1
509 fi
510
Matt Alexanderd9c56562020-05-21 10:49:17 +0000511 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700512 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800513 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000514 if check_product $ANSWER
515 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800516 export TARGET_PRODUCT=$ANSWER
517 else
518 echo "** Not a valid product: $ANSWER"
519 fi
520 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000521 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800522 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700523 fi
524 done
525
Ying Wang08800fd2016-03-03 20:57:21 -0800526 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700527 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800528 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700529}
530
Matt Alexanderd9c56562020-05-21 10:49:17 +0000531function choosevariant()
532{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800533 echo "Variant choices are:"
534 local index=1
535 local v
536 for v in ${VARIANT_CHOICES[@]}
537 do
538 # The product name is the name of the directory containing
539 # the makefile we found, above.
540 echo " $index. $v"
541 index=$(($index+1))
542 done
543
544 local default_value=eng
545 local ANSWER
546
547 export TARGET_BUILD_VARIANT=
548 while [ -z "$TARGET_BUILD_VARIANT" ]
549 do
550 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000551 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800552 read ANSWER
553 else
554 echo $1
555 ANSWER=$1
556 fi
557
Matt Alexanderd9c56562020-05-21 10:49:17 +0000558 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800559 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000560 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
561 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200562 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800563 fi
564 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000565 if check_variant $ANSWER
566 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800567 export TARGET_BUILD_VARIANT=$ANSWER
568 else
569 echo "** Not a valid variant: $ANSWER"
570 fi
571 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000572 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800573 break
574 fi
575 done
576}
577
Matt Alexanderd9c56562020-05-21 10:49:17 +0000578function choosecombo()
579{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700580 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700581
582 echo
583 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700584 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700585
586 echo
587 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700588 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800589
590 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800591 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700592 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800593 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800594 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700595}
596
Matt Alexanderd9c56562020-05-21 10:49:17 +0000597function add_lunch_combo()
598{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800599 if [ -n "$ZSH_VERSION" ]; then
600 echo -n "${funcfiletrace[1]}: "
601 else
602 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
603 fi
604 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800605}
606
Matt Alexanderd9c56562020-05-21 10:49:17 +0000607function print_lunch_menu()
608{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700609 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100610 local choices
Colin Crossfa50d402021-04-22 13:05:41 -0700611 choices=$(TARGET_BUILD_APPS= TARGET_PRODUCT= TARGET_BUILD_VARIANT= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100612 local ret=$?
613
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700614 echo
615 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700616 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100617
Matt Alexanderd9c56562020-05-21 10:49:17 +0000618 if [ $ret -ne 0 ]
619 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100620 echo "Warning: Cannot display lunch menu."
621 echo
622 echo "Note: You can invoke lunch with an explicit target:"
623 echo
624 echo " usage: lunch [target]" >&2
625 echo
626 return
627 fi
628
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700629 echo "Lunch menu... pick a combo:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800630
631 local i=1
632 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700633 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800634 do
635 echo " $i. $choice"
636 i=$(($i+1))
637 done
638
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700639 echo
640}
641
Matt Alexanderd9c56562020-05-21 10:49:17 +0000642function lunch()
643{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800644 local answer
645
Steven Moreland92793dc2020-02-25 18:30:18 -0800646 if [[ $# -gt 1 ]]; then
647 echo "usage: lunch [target]" >&2
648 return 1
649 fi
650
651 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800652 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700653 else
654 print_lunch_menu
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700655 echo -n "Which would you like? [aosp_arm-eng] "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800656 read answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700657 fi
658
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800659 local selection=
660
Matt Alexanderd9c56562020-05-21 10:49:17 +0000661 if [ -z "$answer" ]
662 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700663 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000664 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
665 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800666 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000667 if [ $answer -le ${#choices[@]} ]
668 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800669 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000670 if [ -n "$ZSH_VERSION" ]
671 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800672 selection=${choices[$(($answer))]}
673 else
674 selection=${choices[$(($answer-1))]}
675 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800676 fi
Colin Cross88737132017-03-21 17:41:03 -0700677 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800678 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700679 fi
680
Joe Onoratoda12daf2010-06-09 18:18:31 -0700681 export TARGET_BUILD_APPS=
682
Colin Cross88737132017-03-21 17:41:03 -0700683 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700684 product=${selection%%-*} # Trim everything after first dash
685 variant_and_version=${selection#*-} # Trim everything up to first dash
686 if [ "$variant_and_version" != "$selection" ]; then
687 variant=${variant_and_version%%-*}
688 if [ "$variant" != "$variant_and_version" ]; then
689 version=${variant_and_version#*-}
690 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700691 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800692
Matt Alexanderd9c56562020-05-21 10:49:17 +0000693 if [ -z "$product" ]
694 then
Ying Wang08800fd2016-03-03 20:57:21 -0800695 echo
Colin Cross88737132017-03-21 17:41:03 -0700696 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700697 return 1
698 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800699
Colin Cross88737132017-03-21 17:41:03 -0700700 TARGET_PRODUCT=$product \
701 TARGET_BUILD_VARIANT=$variant \
702 TARGET_PLATFORM_VERSION=$version \
703 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000704 if [ $? -ne 0 ]
705 then
Colin Cross88737132017-03-21 17:41:03 -0700706 return 1
707 fi
Colin Cross88737132017-03-21 17:41:03 -0700708 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
709 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700710 if [ -n "$version" ]; then
711 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
712 else
713 unset TARGET_PLATFORM_VERSION
714 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700715 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700716
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700717 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800718
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700719 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700720 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800721 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700722}
723
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700724unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700725# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000726function _lunch()
727{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700728 local cur prev opts
729 COMPREPLY=()
730 cur="${COMP_WORDS[COMP_CWORD]}"
731 prev="${COMP_WORDS[COMP_CWORD-1]}"
732
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700733 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800734 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700735 fi
736
737 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700738 return 0
739}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700740
Joe Onoratoda12daf2010-06-09 18:18:31 -0700741# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700742# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000743function tapas()
744{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700745 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800746 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700747 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700748 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800749 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Joe Onoratoda12daf2010-06-09 18:18:31 -0700750
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700751 if [ "$showHelp" != "" ]; then
752 $(gettop)/build/make/tapasHelp.sh
753 return
754 fi
755
Ying Wang67f02922012-08-22 10:25:20 -0700756 if [ $(echo $arch | wc -w) -gt 1 ]; then
757 echo "tapas: Error: Multiple build archs supplied: $arch"
758 return
759 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700760 if [ $(echo $variant | wc -w) -gt 1 ]; then
761 echo "tapas: Error: Multiple build variants supplied: $variant"
762 return
763 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700764 if [ $(echo $density | wc -w) -gt 1 ]; then
765 echo "tapas: Error: Multiple densities supplied: $density"
766 return
767 fi
Ying Wang67f02922012-08-22 10:25:20 -0700768
Ying Wang0a76df52015-06-08 11:57:26 -0700769 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700770 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000771 x86) product=aosp_x86;;
772 arm64) product=aosp_arm64;;
773 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700774 esac
Joe Onoratoda12daf2010-06-09 18:18:31 -0700775 if [ -z "$variant" ]; then
776 variant=eng
777 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700778 if [ -z "$apps" ]; then
779 apps=all
780 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600781 if [ -z "$density" ]; then
782 density=alldpi
783 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700784
Ying Wang67f02922012-08-22 10:25:20 -0700785 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700786 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700787 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700788 export TARGET_BUILD_TYPE=release
789 export TARGET_BUILD_APPS=$apps
790
Ying Wang08800fd2016-03-03 20:57:21 -0800791 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700792 set_stuff_for_environment
793 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800794 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700795}
796
Martin Stjernholmf692c752021-04-12 00:01:10 +0100797# Configures the build to build unbundled Android modules (APEXes).
798# Run banchan with one or more module names (from apex{} modules).
799function banchan()
800{
801 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100802 local product="$(echo $* | xargs -n 1 echo | \grep -E '^(.*_)?(arm|x86|arm64|x86_64)$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100803 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100804 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|(.*_)?(arm|x86|arm64|x86_64))$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100805
806 if [ "$showHelp" != "" ]; then
807 $(gettop)/build/make/banchanHelp.sh
808 return
809 fi
810
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100811 if [ -z "$product" ]; then
812 product=arm
813 elif [ $(echo $product | wc -w) -gt 1 ]; then
814 echo "banchan: Error: Multiple build archs or products supplied: $products"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100815 return
816 fi
817 if [ $(echo $variant | wc -w) -gt 1 ]; then
818 echo "banchan: Error: Multiple build variants supplied: $variant"
819 return
820 fi
821 if [ -z "$apps" ]; then
822 echo "banchan: Error: No modules supplied"
823 return
824 fi
825
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100826 case $product in
827 arm) product=module_arm;;
Martin Stjernholmf692c752021-04-12 00:01:10 +0100828 x86) product=module_x86;;
829 arm64) product=module_arm64;;
830 x86_64) product=module_x86_64;;
831 esac
832 if [ -z "$variant" ]; then
833 variant=eng
834 fi
835
836 export TARGET_PRODUCT=$product
837 export TARGET_BUILD_VARIANT=$variant
838 export TARGET_BUILD_DENSITY=alldpi
839 export TARGET_BUILD_TYPE=release
840
841 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
842 # case is different and it may diverge in the future.
843 export TARGET_BUILD_APPS=$apps
844
845 build_build_var_cache
846 set_stuff_for_environment
847 printconfig
848 destroy_build_var_cache
849}
850
Matt Alexanderd9c56562020-05-21 10:49:17 +0000851function gettop
852{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700853 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000854 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700855 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000856 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700857 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000858 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800859 # The following circumlocution (repeated below as well) ensures
860 # that we record the true directory name and not one that is
861 # faked up with symlink names.
862 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700863 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800864 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700865 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000866 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800867 \cd ..
synergyb112a402013-07-05 19:47:47 -0700868 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700869 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000870 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700871 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000872 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700873 fi
874 fi
875 fi
876}
877
Matt Alexanderd9c56562020-05-21 10:49:17 +0000878function croot()
879{
Christopher Ferris55257d22017-03-23 11:08:58 -0700880 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700881 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -0700882 if [ "$1" ]; then
883 \cd $(gettop)/$1
884 else
885 \cd $(gettop)
886 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700887 else
888 echo "Couldn't locate the top of the tree. Try setting TOP."
889 fi
890}
891
Matt Alexanderd9c56562020-05-21 10:49:17 +0000892function _croot()
893{
Anton Hanssonece9c482019-02-04 18:15:39 +0000894 local T=$(gettop)
895 if [ "$T" ]; then
896 local cur="${COMP_WORDS[COMP_CWORD]}"
897 k=0
898 for c in $(compgen -d ${T}/${cur}); do
899 COMPREPLY[k++]=${c#${T}/}/
900 done
901 fi
902}
903
Matt Alexanderd9c56562020-05-21 10:49:17 +0000904function cproj()
905{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700906 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700907 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700908 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700909 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
910 T=$PWD
911 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -0800912 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700913 return
914 fi
Ying Wang9cd17642012-12-13 10:52:07 -0800915 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700916 done
Ying Wang9cd17642012-12-13 10:52:07 -0800917 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700918 echo "can't find Android.mk"
919}
920
Daniel Sandler47e0a882013-07-30 13:23:52 -0400921# simplified version of ps; output in the form
922# <pid> <procname>
923function qpid() {
924 local prepend=''
925 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +0000926 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -0400927 prepend=' '
928 append='$'
929 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +0000930 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -0800931 echo "usage: qpid [[--exact] <process name|pid>"
932 return 255
933 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400934
935 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +0000936 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -0800937 qpid | \grep "$prepend$EXE$append"
938 else
939 adb shell ps \
940 | tr -d '\r' \
941 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
942 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400943}
944
Steven Moreland74114f12020-09-10 01:23:32 +0000945# syswrite - disable verity, reboot if needed, and remount image
946#
947# Easy way to make system.img/etc writable
948function syswrite() {
949 adb wait-for-device && adb root || return 1
950 if [[ $(adb disable-verity | grep "reboot") ]]; then
951 echo "rebooting"
952 adb reboot && adb wait-for-device && adb root || return 1
953 fi
954 adb wait-for-device && adb remount || return 1
955}
956
Iliyan Malcheve675cfb2014-11-03 17:04:47 -0800957# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700958# that has the core-file-size limit set correctly
959#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800960# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700961# if its core-file-size limit is not set already.
962# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
963
Matt Alexanderd9c56562020-05-21 10:49:17 +0000964function coredump_setup()
965{
966 echo "Getting root...";
967 adb root;
968 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700969
Matt Alexanderd9c56562020-05-21 10:49:17 +0000970 echo "Remounting root partition read-write...";
971 adb shell mount -w -o remount -t rootfs rootfs;
972 sleep 1;
973 adb wait-for-device;
974 adb shell mkdir -p /cores;
975 adb shell mount -t tmpfs tmpfs /cores;
976 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700977
Matt Alexanderd9c56562020-05-21 10:49:17 +0000978 echo "Granting SELinux permission to dump in /cores...";
979 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700980
Matt Alexanderd9c56562020-05-21 10:49:17 +0000981 echo "Set core pattern.";
982 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700983
Ying Wang08800fd2016-03-03 20:57:21 -0800984 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700985}
986
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800987# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +0000988# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700989#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800990# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700991# dump to actually be generated.
992
Matt Alexanderd9c56562020-05-21 10:49:17 +0000993function coredump_enable()
994{
995 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -0800996 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +0000997 printf "Expecting a PID!\n";
998 return;
999 fi;
1000 echo "Setting core limit for $PID to infinite...";
Elliott Hughes910a3552016-03-07 13:53:53 -08001001 adb shell /system/bin/ulimit -p $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001002}
1003
1004# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001005# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001006#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001007# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001008# enabled globally.
1009
Matt Alexanderd9c56562020-05-21 10:49:17 +00001010function core()
1011{
1012 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001013
Ying Wang08800fd2016-03-03 20:57:21 -08001014 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001015 printf "Expecting a PID!\n";
1016 return;
1017 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001018
Matt Alexanderd9c56562020-05-21 10:49:17 +00001019 local CORENAME=core.$PID;
1020 local COREPATH=/cores/$CORENAME;
1021 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001022
Matt Alexanderd9c56562020-05-21 10:49:17 +00001023 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001024
Matt Alexanderd9c56562020-05-21 10:49:17 +00001025 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001026 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001027 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1028 adb shell kill -$SIG $PID;
1029 sleep 1;
1030 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001031
Matt Alexanderd9c56562020-05-21 10:49:17 +00001032 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1033 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001034}
1035
Christopher Tate744ee802009-11-12 15:33:08 -08001036# systemstack - dump the current stack trace of all threads in the system process
1037# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001038function systemstack()
1039{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001040 stacks system_server
1041}
1042
Michael Wrightaeed7212014-06-19 19:58:12 -07001043# Read the ELF header from /proc/$PID/exe to determine if the process is
1044# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001045function is64bit()
1046{
Ben Chengfba67bf2014-02-25 10:27:07 -08001047 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001048 if [ "$PID" ] ; then
1049 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001050 echo "64"
1051 else
1052 echo ""
1053 fi
1054 else
1055 echo ""
1056 fi
1057}
1058
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001059case `uname -s` in
1060 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001061 function sgrep()
1062 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001063 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001064 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001065 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001066
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001067 ;;
1068 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001069 function sgrep()
1070 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001071 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001072 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001073 }
1074 ;;
1075esac
1076
Matt Alexanderd9c56562020-05-21 10:49:17 +00001077function gettargetarch
1078{
Raghu Gandham8da43102012-07-25 19:57:22 -07001079 get_build_var TARGET_ARCH
1080}
1081
Matt Alexanderd9c56562020-05-21 10:49:17 +00001082function ggrep()
1083{
Mike Frysinger5e479732015-09-22 18:13:48 -04001084 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1085 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001086}
1087
Matt Alexanderd9c56562020-05-21 10:49:17 +00001088function gogrep()
1089{
Orion Hodson831472d2019-10-25 11:35:15 +01001090 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1091 -exec grep --color -n "$@" {} +
1092}
1093
Matt Alexanderd9c56562020-05-21 10:49:17 +00001094function jgrep()
1095{
Mike Frysinger5e479732015-09-22 18:13:48 -04001096 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1097 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001098}
1099
Alistair Delva176e5342021-02-22 13:31:26 -08001100function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001101{
1102 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1103 -exec grep --color -n "$@" {} +
1104}
1105
Taesu Leeea0cecd2020-10-28 11:05:18 +09001106function ktgrep()
1107{
1108 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1109 -exec grep --color -n "$@" {} +
1110}
1111
Matt Alexanderd9c56562020-05-21 10:49:17 +00001112function cgrep()
1113{
Mike Frysinger5e479732015-09-22 18:13:48 -04001114 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1115 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001116}
1117
Matt Alexanderd9c56562020-05-21 10:49:17 +00001118function resgrep()
1119{
Christopher Ferris55257d22017-03-23 11:08:58 -07001120 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001121 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1122 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1123 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001124}
1125
Matt Alexanderd9c56562020-05-21 10:49:17 +00001126function mangrep()
1127{
Mike Frysinger5e479732015-09-22 18:13:48 -04001128 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1129 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001130}
1131
Matt Alexanderd9c56562020-05-21 10:49:17 +00001132function owngrep()
1133{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001134 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1135 -exec grep --color -n "$@" {} +
1136}
1137
Matt Alexanderd9c56562020-05-21 10:49:17 +00001138function sepgrep()
1139{
Mike Frysinger5e479732015-09-22 18:13:48 -04001140 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1141 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001142}
1143
Matt Alexanderd9c56562020-05-21 10:49:17 +00001144function rcgrep()
1145{
Mike Frysinger5e479732015-09-22 18:13:48 -04001146 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1147 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001148}
1149
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001150case `uname -s` in
1151 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001152 function mgrep()
1153 {
Orion Hodson831472d2019-10-25 11:35:15 +01001154 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001155 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001156 }
1157
Matt Alexanderd9c56562020-05-21 10:49:17 +00001158 function treegrep()
1159 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001160 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001161 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001162 }
1163
1164 ;;
1165 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001166 function mgrep()
1167 {
Orion Hodson831472d2019-10-25 11:35:15 +01001168 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001169 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001170 }
1171
Matt Alexanderd9c56562020-05-21 10:49:17 +00001172 function treegrep()
1173 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001174 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001175 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001176 }
1177
1178 ;;
1179esac
1180
Matt Alexanderd9c56562020-05-21 10:49:17 +00001181function getprebuilt
1182{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001183 get_abs_build_var ANDROID_PREBUILTS
1184}
1185
Matt Alexanderd9c56562020-05-21 10:49:17 +00001186function tracedmdump()
1187{
Christopher Ferris55257d22017-03-23 11:08:58 -07001188 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001189 if [ ! "$T" ]; then
1190 echo "Couldn't locate the top of the tree. Try setting TOP."
1191 return
1192 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001193 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001194 local arch=$(gettargetarch)
1195 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001196
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001197 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001198 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001199 echo "usage: tracedmdump tracename"
1200 return
1201 fi
1202
Matt Alexanderd9c56562020-05-21 10:49:17 +00001203 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001204 echo "Error: cannot find kernel: '$KERNEL'"
1205 return
1206 fi
1207
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001208 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001209 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001210 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1211 fi
1212
1213 echo "post-processing traces..."
1214 rm -f $TRACE/qtrace.dexlist
1215 post_trace $TRACE
1216 if [ $? -ne 0 ]; then
1217 echo "***"
1218 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1219 echo "***"
1220 return
1221 fi
1222 echo "generating dexlist output..."
1223 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1224 echo "generating dmtrace data..."
1225 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1226 echo "generating html file..."
1227 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1228 echo "done, see $TRACE/dmtrace.html for details"
1229 echo "or run:"
1230 echo " traceview $TRACE/dmtrace"
1231}
1232
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001233# communicate with a running device or emulator, set up necessary state,
1234# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001235function runhat()
1236{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001237 # process standard adb options
1238 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001239 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001240 adbTarget=$1
1241 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001242 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001243 adbTarget="$1 $2"
1244 shift 2
1245 fi
1246 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001247 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001248
1249 # runhat options
1250 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001251
Matt Alexanderd9c56562020-05-21 10:49:17 +00001252 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001253 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001254 return
1255 fi
1256
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001257 # confirm hat is available
1258 if [ -z $(which hat) ]; then
1259 echo "hat is not available in this configuration."
1260 return
1261 fi
1262
Andy McFaddenb6289852010-07-12 08:00:19 -07001263 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001264 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001265 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001266 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001267 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001268 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001269 echo -n "> "
1270 read
1271
The Android Open Source Project88b60792009-03-03 19:28:42 -08001272 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001273
The Android Open Source Project88b60792009-03-03 19:28:42 -08001274 echo "Retrieving file $devFile..."
1275 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001276
The Android Open Source Project88b60792009-03-03 19:28:42 -08001277 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001278
The Android Open Source Project88b60792009-03-03 19:28:42 -08001279 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001280 echo "View the output by pointing your browser at http://localhost:7000/"
1281 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001282 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001283}
1284
Matt Alexanderd9c56562020-05-21 10:49:17 +00001285function getbugreports()
1286{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001287 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001288
1289 if [ ! "$reports" ]; then
1290 echo "Could not locate any bugreports."
1291 return
1292 fi
1293
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001294 local report
1295 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001296 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001297 echo "/sdcard/bugreports/${report}"
1298 adb pull /sdcard/bugreports/${report} ${report}
1299 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001300 done
1301}
1302
Matt Alexanderd9c56562020-05-21 10:49:17 +00001303function getsdcardpath()
1304{
Victoria Lease1b296b42012-08-21 15:44:06 -07001305 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1306}
1307
Matt Alexanderd9c56562020-05-21 10:49:17 +00001308function getscreenshotpath()
1309{
Victoria Lease1b296b42012-08-21 15:44:06 -07001310 echo "$(getsdcardpath)/Pictures/Screenshots"
1311}
1312
Matt Alexanderd9c56562020-05-21 10:49:17 +00001313function getlastscreenshot()
1314{
Victoria Lease1b296b42012-08-21 15:44:06 -07001315 local screenshot_path=$(getscreenshotpath)
1316 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001317 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001318 echo "No screenshots found."
1319 return
1320 fi
1321 echo "${screenshot}"
1322 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1323}
1324
Matt Alexanderd9c56562020-05-21 10:49:17 +00001325function startviewserver()
1326{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001327 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001328 if [ $# -gt 0 ]; then
1329 port=$1
1330 fi
1331 adb shell service call window 1 i32 $port
1332}
1333
Matt Alexanderd9c56562020-05-21 10:49:17 +00001334function stopviewserver()
1335{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001336 adb shell service call window 2
1337}
1338
Matt Alexanderd9c56562020-05-21 10:49:17 +00001339function isviewserverstarted()
1340{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001341 adb shell service call window 3
1342}
1343
Matt Alexanderd9c56562020-05-21 10:49:17 +00001344function key_home()
1345{
Romain Guyb84049a2010-10-04 16:56:11 -07001346 adb shell input keyevent 3
1347}
1348
Matt Alexanderd9c56562020-05-21 10:49:17 +00001349function key_back()
1350{
Romain Guyb84049a2010-10-04 16:56:11 -07001351 adb shell input keyevent 4
1352}
1353
Matt Alexanderd9c56562020-05-21 10:49:17 +00001354function key_menu()
1355{
Romain Guyb84049a2010-10-04 16:56:11 -07001356 adb shell input keyevent 82
1357}
1358
Matt Alexanderd9c56562020-05-21 10:49:17 +00001359function smoketest()
1360{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001361 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1362 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1363 return
1364 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001365 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001366 if [ ! "$T" ]; then
1367 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1368 return
1369 fi
1370
Ying Wang9cd17642012-12-13 10:52:07 -08001371 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001372 adb uninstall com.android.smoketest > /dev/null &&
1373 adb uninstall com.android.smoketest.tests > /dev/null &&
1374 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1375 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1376 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1377}
1378
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001379# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001380function runtest()
1381{
Christopher Ferris55257d22017-03-23 11:08:58 -07001382 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001383 if [ ! "$T" ]; then
1384 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1385 return
1386 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001387 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001388}
1389
The Android Open Source Project88b60792009-03-03 19:28:42 -08001390function godir () {
1391 if [[ -z "$1" ]]; then
1392 echo "Usage: godir <regex>"
1393 return
1394 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001395 local T=$(gettop)
1396 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001397 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001398 mkdir -p $OUT_DIR
1399 FILELIST=$OUT_DIR/filelist
1400 else
1401 FILELIST=$T/filelist
1402 fi
1403 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001404 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001405 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001406 echo " Done"
1407 echo ""
1408 fi
1409 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001410 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001411 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001412 echo "Not found"
1413 return
1414 fi
1415 local pathname
1416 local choice
1417 if [[ ${#lines[@]} > 1 ]]; then
1418 while [[ -z "$pathname" ]]; do
1419 local index=1
1420 local line
1421 for line in ${lines[@]}; do
1422 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001423 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001424 done
1425 echo
1426 echo -n "Select one: "
1427 unset choice
1428 read choice
1429 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1430 echo "Invalid choice"
1431 continue
1432 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001433 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001434 done
1435 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001436 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001437 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001438 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001439}
1440
Steven Moreland62054a42018-12-06 10:11:40 -08001441# Update module-info.json in out.
1442function refreshmod() {
1443 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1444 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1445 return 1
1446 fi
1447
1448 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1449
1450 # for the output of the next command
1451 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1452
1453 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001454 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001455 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1456}
1457
Cole Faust24c36db2021-01-23 02:39:37 +00001458# Verifies that module-info.txt exists, creating it if it doesn't.
1459function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001460 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1461 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1462 return 1
1463 fi
1464
1465 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
1466 echo "Could not find module-info.json. It will only be built once, and it can be updated with 'refreshmod'" >&2
1467 refreshmod || return 1
1468 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001469}
1470
1471# List all modules for the current device, as cached in module-info.json. If any build change is
1472# made and it should be reflected in the output, you should run 'refreshmod' first.
1473function allmod() {
1474 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001475
LuK1337b6a78192020-01-12 03:12:17 +01001476 python -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001477}
1478
Joe Onorato2c1aa472021-02-25 16:42:39 -08001479# Get the path of a specific module in the android tree, as cached in module-info.json.
1480# If any build change is made, and it should be reflected in the output, you should run
1481# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001482function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001483 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001484 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001485 return 1
1486 fi
1487
Cole Faust24c36db2021-01-23 02:39:37 +00001488 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001489
1490 local relpath=$(python -c "import json, os
1491module = '$1'
1492module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1493if module not in module_info:
1494 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001495print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001496
1497 if [ -z "$relpath" ]; then
1498 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1499 return 1
1500 else
Rett Berg78d1c932019-01-24 14:34:23 -08001501 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001502 fi
1503}
1504
Joe Onorato2c1aa472021-02-25 16:42:39 -08001505# Get the path of a specific module in the android tree, as cached in module-info.json.
1506# If any build change is made, and it should be reflected in the output, you should run
1507# 'refreshmod' first. Note: This is the inverse of pathmod.
1508function dirmods() {
1509 if [[ $# -ne 1 ]]; then
1510 echo "usage: dirmods <path>" >&2
1511 return 1
1512 fi
1513
1514 verifymodinfo || return 1
1515
1516 python -c "import json, os
1517dir = '$1'
1518while dir.endswith('/'):
1519 dir = dir[:-1]
1520prefix = dir + '/'
1521module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1522results = set()
1523for m in module_info.values():
1524 for path in m.get(u'path', []):
1525 if path == dir or path.startswith(prefix):
1526 name = m.get(u'module_name')
1527 if name:
1528 results.add(name)
1529for name in sorted(results):
1530 print(name)
1531"
1532}
1533
1534
Rett Berg78d1c932019-01-24 14:34:23 -08001535# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1536# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1537function gomod() {
1538 if [[ $# -ne 1 ]]; then
1539 echo "usage: gomod <module>" >&2
1540 return 1
1541 fi
1542
1543 local path="$(pathmod $@)"
1544 if [ -z "$path" ]; then
1545 return 1
1546 fi
1547 cd $path
1548}
1549
Cole Faust24c36db2021-01-23 02:39:37 +00001550# Gets the list of a module's installed outputs, as cached in module-info.json.
1551# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1552function outmod() {
1553 if [[ $# -ne 1 ]]; then
1554 echo "usage: outmod <module>" >&2
1555 return 1
1556 fi
1557
1558 verifymodinfo || return 1
1559
1560 local relpath
1561 relpath=$(python -c "import json, os
1562module = '$1'
1563module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1564if module not in module_info:
1565 exit(1)
1566for output in module_info[module]['installed']:
1567 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1568
1569 if [ $? -ne 0 ]; then
1570 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1571 return 1
1572 elif [ ! -z "$relpath" ]; then
1573 echo "$relpath"
1574 fi
1575}
1576
1577# adb install a module's apk, as cached in module-info.json. If any build change
1578# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1579# Usage: installmod [adb install arguments] <module>
1580# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1581function installmod() {
1582 if [[ $# -eq 0 ]]; then
1583 echo "usage: installmod [adb install arguments] <module>" >&2
1584 return 1
1585 fi
1586
1587 local _path
1588 _path=$(outmod ${@:$#:1})
1589 if [ $? -ne 0 ]; then
1590 return 1
1591 fi
1592
1593 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1594 if [ -z "$_path" ]; then
1595 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1596 return 1
1597 fi
1598 local length=$(( $# - 1 ))
1599 echo adb install ${@:1:$length} $_path
1600 adb install ${@:1:$length} $_path
1601}
1602
dimitry73b84812018-12-11 18:06:00 +01001603function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001604 local word=${COMP_WORDS[COMP_CWORD]}
1605 COMPREPLY=( $(allmod | grep -E "^$word") )
1606}
1607
Alex Rayf0d08eb2013-03-08 15:15:06 -08001608# Print colored exit condition
1609function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001610 "$@"
1611 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001612 if [ $retval -ne 0 ]
1613 then
Jacky Cao89483b82015-05-15 22:12:53 +08001614 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001615 else
Jacky Cao89483b82015-05-15 22:12:53 +08001616 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001617 fi
1618 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001619}
1620
Matt Alexanderd9c56562020-05-21 10:49:17 +00001621function get_make_command()
1622{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001623 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1624 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001625 # Always use the real make if -C is passed in
1626 for arg in "$@"; do
1627 if [[ $arg == -C* ]]; then
1628 echo command make
1629 return
1630 fi
1631 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001632 echo build/soong/soong_ui.bash --make-mode
1633 else
1634 echo command make
1635 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001636}
1637
Matt Alexanderd9c56562020-05-21 10:49:17 +00001638function _wrap_build()
1639{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001640 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1641 "$@"
1642 return $?
1643 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001644 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001645 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001646 local ret=$?
1647 local end_time=$(date +"%s")
1648 local tdiff=$(($end_time-$start_time))
1649 local hours=$(($tdiff / 3600 ))
1650 local mins=$((($tdiff % 3600) / 60))
1651 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001652 local ncolors=$(tput colors 2>/dev/null)
1653 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001654 color_failed=$'\E'"[0;31m"
1655 color_success=$'\E'"[0;32m"
1656 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001657 else
1658 color_failed=""
1659 color_success=""
1660 color_reset=""
1661 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001662 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001663 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001664 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001665 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001666 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001667 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001668 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001669 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001670 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001671 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001672 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001673 printf "(%s seconds)" $secs
1674 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001675 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001676 echo
1677 return $ret
1678}
1679
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001680function _trigger_build()
1681(
1682 local -r bc="$1"; shift
1683 if T="$(gettop)"; then
1684 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1685 else
1686 echo "Couldn't locate the top of the tree. Try setting TOP."
1687 fi
1688)
1689
1690function m()
1691(
1692 _trigger_build "all-modules" "$@"
1693)
1694
1695function mm()
1696(
1697 _trigger_build "modules-in-a-dir-no-deps" "$@"
1698)
1699
1700function mmm()
1701(
1702 _trigger_build "modules-in-dirs-no-deps" "$@"
1703)
1704
1705function mma()
1706(
1707 _trigger_build "modules-in-a-dir" "$@"
1708)
1709
1710function mmma()
1711(
1712 _trigger_build "modules-in-dirs" "$@"
1713)
1714
Matt Alexanderd9c56562020-05-21 10:49:17 +00001715function make()
1716{
Dan Willemsene9842242017-07-28 13:00:13 -07001717 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001718}
1719
Matt Alexanderd9c56562020-05-21 10:49:17 +00001720function provision()
1721{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001722 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1723 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1724 return 1
1725 fi
1726 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1727 echo "There is no provisioning script for the device." >&2
1728 return 1
1729 fi
1730
1731 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001732 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001733 shift 1
1734 else
1735 echo "This action will reflash your device."
1736 echo ""
1737 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1738 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001739 echo -n "Are you sure you want to do this (yes/no)? "
1740 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001741 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001742 echo "Not taking any action. Exiting." >&2
1743 return 1
1744 fi
1745 fi
1746 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1747}
1748
Jim Tanga881a252018-06-19 16:34:41 +08001749# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001750function enable_zsh_completion() {
1751 # Don't override user's options if bash-style completion is already enabled.
1752 if ! declare -f complete >/dev/null; then
1753 autoload -U compinit && compinit
1754 autoload -U bashcompinit && bashcompinit
1755 fi
Jim Tanga881a252018-06-19 16:34:41 +08001756}
1757
1758function validate_current_shell() {
1759 local current_sh="$(ps -o command -p $$)"
1760 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001761 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001762 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001763 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001764 *zsh*)
1765 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001766 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001767 *)
Jim Tanga881a252018-06-19 16:34:41 +08001768 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001769 ;;
1770 esac
Jim Tanga881a252018-06-19 16:34:41 +08001771}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001772
1773# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001774# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1775# load those.
1776#
1777# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001778function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001779 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001780 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001781 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001782 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001783 if [ -n "$allowed" ]; then
1784 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1785 echo " $allowed"
1786 echo " $f"
1787 return
1788 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001789 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001790 done
1791
1792 allowed_files=
1793 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08001794 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001795 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08001796 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001797
1798 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001799 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001800 else
1801 echo "ignoring $f, not in $allowed"
1802 fi
Jim Tanga881a252018-06-19 16:34:41 +08001803 done
1804 done
1805}
Kenny Root52aa81c2011-07-15 11:07:06 -07001806
Dan Albertbab814f2020-08-26 15:34:53 -07001807function showcommands() {
1808 local T=$(gettop)
1809 if [[ -z "$TARGET_PRODUCT" ]]; then
1810 >&2 echo "TARGET_PRODUCT not set. Run lunch."
1811 return
1812 fi
1813 case $(uname -s) in
1814 Darwin)
1815 PREBUILT_NAME=darwin-x86
1816 ;;
1817 Linux)
1818 PREBUILT_NAME=linux-x86
1819 ;;
1820 *)
1821 >&2 echo Unknown host $(uname -s)
1822 return
1823 ;;
1824 esac
1825 if [[ -z "$OUT_DIR" ]]; then
1826 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
1827 OUT_DIR=out
1828 else
1829 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
1830 fi
1831 fi
1832 if [[ "$1" == "--regenerate" ]]; then
1833 shift 1
1834 NINJA_ARGS="-t commands $@" m
1835 else
1836 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
1837 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
1838 -t commands "$@")
1839 fi
1840}
1841
Jim Tanga881a252018-06-19 16:34:41 +08001842validate_current_shell
1843source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07001844addcompletions